<?php
/**
* SEF advance component extension
*
* This extension will give the SEF advance style URLs to the userlist component
* Place this file (sef_ext.php) in the main component directory
* Note that class must be named: sef_componentname
*
* Copyright (C) 2003-2004 Emir Sakic, http://www.sakic.net, All rights reserved.
*
* Comments: for SEF advance > v3.6
*
* For Joomnik Gallery component, v. 0.9.  2007-04-28 by Konrad from www.anetus.com
* Advanced version, creating urls like: /3-album-name/23-item-name/ or /3-album_name/page-2.html
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class sef_joomnik {

    /**
    * Creates the SEF advance URL out of the Mambo request
    * Input: $string, string, The request URL (index.php?option=com_example&Itemid=$Itemid)
    * Output: $sefstring, string, SEF advance URL ($var1/$var2/)
    **/
    function create ($string) {
		global $database;
        // $string == "index.php?option=com_joomnik&Itemid=$Itemid&var1=$var1&var2=$var2"
				// option,com_joomnik/album,19/task,photo/id,26/Itemid,26/page,2/
         $sefstring = "";
        if (eregi("&amp;album=",$string)) {
            $temp = split("&amp;album=", $string);
            $temp = split("&", $temp[1]);
            //$sefstring .= $temp[0]."/";
							//echo $string.'-'.$temp[0];
						if ($temp[0])
						{
						$database->setQuery('SELECT album_name FROM #__joomnik_albums WHERE id = '.$temp[0]);
            $rows = $database->loadObjectList();

            if ($debug){$GLOBALS['404SEF_DEBUG']['CLASS_SEF_404'][$debug_string][$option] = $rows;}
            if ($database->getErrorNum()) {
                die($database->stderr());
            }						
						$sefstring .= $temp[0].'-'.$rows[0]->album_name.'/'; 
						}
						else
						$sefstring .= $temp[0].'/';

        }
         if (eregi("&amp;task=",$string)) {
            $temp = split("&amp;task=", $string);
            $temp = split("&", $temp[1]);
            //$sefstring .= $temp[0]."/";					// to not show 'photo'
						
						
        }
				if (eregi("&amp;id=",$string)) {
            $temp = split("&amp;id=", $string);
            $temp = split("&", $temp[1]);
            //$sefstring .= $temp[0]."/";
						if ($temp[0])
						{
						$database->setQuery('SELECT item_name FROM #__joomnik_items WHERE id = '.$temp[0]);
            $rows = $database->loadObjectList();

            if ($debug){$GLOBALS['404SEF_DEBUG']['CLASS_SEF_404'][$debug_string][$option] = $rows;}
            if ($database->getErrorNum()) {
                die($database->stderr());
            }
						$sefstring .= $temp[0].'-'.$rows[0]->item_name.'/';
						}
						else
						$sefstring .= $temp[0].'/';
        }
				
				// pages
				if (eregi("&amp;page=",$string)) {
            $temp = split("&amp;page=", $string);
            $temp = split("&", $temp[1]);
            if ($temp[0]) $sefstring .= 'page-'.$temp[0]."/";					// if page exists						
						
        }
				
        // $sefstring == "$var1/$var2/"
        return $sefstring;
    }

    /**
    * Reverts to the Mambo query string out of the SEF advance URL
    * Input:
    *    $url_array, array, The SEF advance URL split in arrays (first custom virtual directory beginning at $pos+1)
    *    $pos, int, The position of the first virtual directory (component)
    * Output: $QUERY_STRING, string, Mambo query string (var1=$var1&var2=$var2)
    *    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
    **/
    function revert ($url_array, $pos) {
        // define all variables you pass as globals
        global $var1, $var2, $var3, $var4;
         // Examine the SEF advance URL and extract the variables building the query string
        $QUERY_STRING = "";
        if (isset($url_array[$pos+2]) && $url_array[$pos+2]!="") {
            // component/example/$var1/
            $var1 = $url_array[$pos+2];
					$var1 = substr($var1, 0, strpos($var1,' ')); // space not -
            $_GET['album'] = $var1;
            $_REQUEST['album'] = $var1;
            $QUERY_STRING .= "&album=$var1";
        }
				// with 'photo' task:
         //if (isset($url_array[$pos+3]) && $url_array[$pos+3]!="") {
            // component/example/$var1/$var2/
          //  $var2 = $url_array[$pos+3];
          //  $_GET['task'] = $var2;
          //  $_REQUEST['task'] = $var2;
          //  $QUERY_STRING .= "&task=$var2";
        //}
				
        //if (isset($url_array[$pos+4]) && $url_array[$pos+4]!="") {
            // component/example/$var1/$var2/
           // $var3 = $url_array[$pos+4]; 						
					//$var3 = substr($var3, 0, strpos($var3,' ')); // space not -
          //  $_GET['id'] = $var3;
          //  $_REQUEST['id'] = $var3;
          //  $QUERY_STRING .= "&id=$var3";// echo $var3;
        //}
				
				// without 'photo' task (and with page):
				if (isset($url_array[$pos+3]) && $url_array[$pos+3]!="") {
            // component/example/$var1/$var2/
            $var3 = $url_array[$pos+3]; 			
						$var4 = $var3;
					$var3 = substr($var3, 0, strpos($var3,' ')); // space not -
					if ($var3 == 'page')
					{
					  $var4 = substr($var4, strpos($var4,' '), strlen($var4)); // space not -
            $_GET['page'] = $var4;
            $_REQUEST['page'] = $var4;
            $QUERY_STRING .= "&page=$var4";
					}
					else
					{
					$_GET['task'] = 'photo';
          $_REQUEST['task'] = 'photo';
          $QUERY_STRING .= "&task=photo";
            $_GET['id'] = $var3;
            $_REQUEST['id'] = $var3;
            $QUERY_STRING .= "&id=$var3";
					}
        }

				
        // $QUERY_STRING == "var1=$var1&var2=$var2";
				
        return $QUERY_STRING;
    }

}
?>